package com.jiuqi.db.impl;

import com.jiuqi.util.DateUtil;
import java.util.Date;
import com.jiuqi.db.DBFunction;

public class OracleDBFunction extends DBFunction
{
    private static final String STR_LINK_SYMBOL = "||";
    private static final String FUNC_NAME_CEILING = "CEIL";
    private static final String FUNC_NAME_LN = "LN";
    private static final String FUNC_NAME_LOG10 = "LOG";
    private static final String FUNC_NAME_CHR = "CHR";
    private static final String FUNC_NAME_POS = "INSTR";
    private static final String FUNC_NAME_LEFT = "SUBSTRB";
    private static final String FUNC_NAME_RIGHT = "SUBSTRB";
    private static final String FUNC_NAME_SUBSTR = "SUBSTRB";
    private static final String FUNC_NAME_LEN = "LENGTH";
    private static final String FUNC_NAME_MOD = "MOD";
    private static final String FUNC_NAME_STR = "TO_CHAR";
    private static final String FUNC_NAME_VAL = "TO_NUMBER";
    private static final String FUNC_NAME_DATE = "TO_DATE";
    
    public String strLinkSymbol() {
        return "||";
    }
    
    public boolean supportEmptyString() {
        return false;
    }
    
    public String ceiling(final String numeric_expression) {
        return this.format("CEIL", numeric_expression);
    }
    
    public String ln(final String numeric_expression) {
        return this.format("LN", numeric_expression);
    }
    
    public String log10(final String numeric_expression) {
        return this.format("LOG", numeric_expression, "10");
    }
    
    public String mod(final String numeric_expression1, final String numeric_expression2) {
        return this.format("MOD", numeric_expression1, numeric_expression2);
    }
    
    public String chr(final String int_expression) {
        return this.format("CHR", int_expression);
    }
    
    public String pos(final String substr_expression, final String str_expression) {
        return this.format("INSTR", str_expression, substr_expression);
    }
    
    public String left(final String str_expression, final String length_expression) {
        return this.format("SUBSTRB", str_expression, "1", length_expression);
    }
    
    public String right(final String str_expression, final String length_expression) {
        return this.format("SUBSTRB", str_expression, this.formatmidopt(this.len(str_expression), "-", String.valueOf(length_expression) + "+1"), length_expression);
    }
    
    public String str(final String numeric_expression) {
        return this.format("TO_CHAR", numeric_expression);
    }
    
    public String substr(final String str_expression, final String from_expression, final String length_expression) {
        return this.format("SUBSTRB", str_expression, from_expression, length_expression);
    }
    
    public String len(final String str_expression) {
        return this.format("LENGTH", str_expression);
    }
    
    public String val(final String str_expression) {
        return this.format("TO_NUMBER", str_expression);
    }
    
    public String date(final Date dateVal) {
        final StringBuffer sql = new StringBuffer();
        sql.append("TO_DATE");
        sql.append("('");
        sql.append(DateUtil.convertDateToString1(dateVal));
        sql.append("','yyyy-MM-dd')");
        return sql.toString();
    }
}
